POJ 2386——Lake Counting

链接:http://poj.org/problem?id=2386

题解

#include<cstdio>
#include<stack>
using namespace std;

const int MAX_M=105,MAX_N=105;
char a[MAX_N][MAX_M];
int N,M;
//现在位置 (x,y)
void dfs(int x,int y){
    a[x][y]=‘.‘; //将现在所在位置替换为‘.‘,即旱地
    for(int dx=-1;dx<=1;dx++){ //循环遍历连通的8个方向:上、下、左、右、左上、左下、右上、右下
        for(int dy=-1;dy<=1;dy++){
            int nx=x+dx,ny=y+dy; //向x方向移动dx,向y方向移动dy,移动的结果为(nx,ny)
            if(0<=nx && nx<N && 0<=ny && ny<M && a[nx][ny]==‘W‘){ //判断(nx,ny)是否在园子里,以及是否有积水
                dfs(nx, ny);
            }
        }
    }
}

//每个 W 看成"水渍",满足八连通条件时构成积水;单独一块"水渍"也看成积水
int main(){
    scanf("%d%d",&N,&M);
    for(int i=0;i<N;++i){
        scanf("%s",a[i]);
    }
    int res=0;
    for(int i=0;i<N;++i){
        for(int j=0;j<M;++j){
            if(a[i][j]==‘W‘){ //只有检测到水渍时才执行该函数
                res++; //凡检测到"水渍",res 先加一,至少这里可以形成水坑 

                //从有 W 的地方开始 dfs
                //dfs 函数的作用是把该点的八连通区域变成旱地,以免后续遍历时重复计数
                //同时通过递归的思想把八连通区域中,每个元素对应的八连通区域遍历一遍,查找是否有其他"水渍"可构成积水
                dfs(i,j);
            }
        }
    }
    printf("%d",res);
    return 0;
}

本题采用深度优先搜索

遍历数组,从第一个 ‘ W ‘ 开始,把它对应的八连通区域中的 ‘ W ‘ 用 ‘ . ‘ 代替

每调用一次 dfs 函数,与初始的 ‘ W ‘ 连通的所有 ‘ W ‘ 就全都被替换成 ‘ . ‘,直到图中不再存在 ‘ W ‘ 为止,总共调用 dfs 函数的次数就是答案

8个方向对应8个状态转移,每个格子作为 dfs 的参数最多调用一次,时间复杂度:O(8 * n * m) = O(n * m)


八连通

*  *  *

* W *    (八连通指的就是左图中相对 W 的 * 的部分)

*  *  *

深度优先搜索(与递归和栈关系密切)

深度优先搜索从某个状态开始,不断地转移状态直到无法转移,然后回退到前一步的状态,继续转移到其它状态;如此不断重复,直到找到最终解

例如求解数独,首先在某个格子内填入适当的数字,然后继续在下一个格子内填入数字,如此重复。如果发现某个格子无解,就放弃前一个格子选择的数字,改用其他可行的数字

深度优先搜索时,有时早已很明确地知道从当前状态无论如何转移都不会存在解。这种情况下,不再继续搜索而直接跳过,该方法称为剪枝

原文地址:https://www.cnblogs.com/E-mperor/p/11336316.html

时间: 2024-10-24 13:54:09

POJ 2386——Lake Counting的相关文章

POJ 2386 Lake Counting 搜索题解

简单的深度搜索就可以了,看见有人说什么使用并查集,那简直是大算法小用了. 因为可以深搜而不用回溯,故此效率就是O(N*M)了. 技巧就是增加一个标志P,每次搜索到池塘,即有W字母,那么就认为搜索到一个池塘了,P值为真. 搜索过的池塘不要重复搜索,故此,每次走过的池塘都改成其他字母,如'@',或者'#',随便一个都可以. 然后8个方向搜索. #include <stdio.h> #include <vector> #include <string.h> #include

《挑战》2.1 POJ 2386 Lake Counting (简单的dfs)

1 # include<cstdio> 2 # include<iostream> 3 4 using namespace std; 5 6 # define MAX 123 7 8 char grid[MAX][MAX]; 9 int nxt[8][2] = { {1,0},{0,-1},{-1,0},{0,1},{1,1},{1,-1},{-1,1},{-1,-1} }; 10 int n,m; 11 12 int can_move( int x,int y ) 13 { 14

poj 2386 Lake Counting

Lake Counting Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 24578   Accepted: 12407 Description Due to recent rains, water has pooled in various places in Farmer John's field, which is represented by a rectangle of N x M (1 <= N <= 10

poj 2386 Lake Counting(BFS解法)

Lake Counting Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 45142   Accepted: 22306 Description Due to recent rains, water has pooled in various places in Farmer John's field, which is represented by a rectangle of N x M (1 <= N <= 10

POJ 2386 - Lake Counting 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2386 题目大意: 给出一张N*M的地图(1<=N,M<=100),地图上的W表示水坑,.表示陆地.水坑是八方向连通的,问图中一共有多少个水坑. Sample Input 9 5 2 1 5 2 1 5 2 1 4 1 2 3 4 0 Sample Output 6 5 分析: 非常简单的深搜.两重循环遍历这个地图,遇到W就dfs来求出这一整个大水坑,并把搜索过

poj - 2386 Lake Counting &amp;&amp; hdoj -1241Oil Deposits (简单dfs)

http://poj.org/problem?id=2386 http://acm.hdu.edu.cn/showproblem.php?pid=1241 求有多少个连通子图.复杂度都是O(n*m). 1 #include <cstdio> 2 3 char filed[110][110]; 4 int n,m; 5 void dfs(int x,int y) 6 { 7 for(int i=-1;i<=1;i++) 8 for(int j=-1;j<=1;j++) //循环遍历8

POJ 2386 Lake Counting (水题,DFS)

题意:给定一个n*m的矩阵,让你判断有多少个连通块. 析:用DFS搜一下即可. 代码如下: #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include <string> #include <cstdlib> #include <cmath> #include <iostream> #include <cstring&

POJ 2386 lake counting DFS

朴素DFS 计算有多少个水坑 TEST 10 12 W........WW. .WWW.....WWW ....WW...WW. .........WW. .........W.. ..W......W.. .W.W.....WW. W.W.W.....W. .W.W......W. ..W.......W. 3 /* DFS,挑战程序设计竞赛 巫 */ #include<cstdio> #include<iostream> using namespace std; string

dfs/poj 2386 Lake Counting

1 #include<cstdio> 2 using namespace std; 3 const int b[8][2]={{-1,-1},{-1,0},{-1,1},{1,-1},{1,0},{1,1},{0,-1},{0,1}}; 4 int n,m; 5 char a[110][110]; 6 7 void dfs(int x,int y) 8 { 9 a[x][y]='.'; 10 for (int k=0;k<8;k++) 11 { 12 int dx=x+b[k][0];